<?php
// $Id: callback_add_url.inc,v 1.1.2.1 2011/01/04 22:18:57 drunkenmonkey Exp $

/**
 * Search API data alteration callback that adds an URL field for all items.
 */
class SearchApiAlterAddUrl extends SearchApiAbstractAlterCallback {

  public function alterItems(array &$items) {
    $type = $this->index->entity_type;
    foreach ($items as $id => &$item) {
      $url = entity_uri($type, $item);
      if (!$url) {
        $item->search_api_url = NULL;
        continue;
      }
      $item->search_api_url = url($url['path'], array('absolute' => TRUE) + $url['options']);
    }
  }

  public function propertyInfo() {
    return array(
      'search_api_url' => array(
        'label' => t('URI'),
        'description' => t('An URI where the item can be accessed.'),
        'type' => 'uri',
      ),
    );
  }

}
